//+------------------------------------------------------------------+
//|                                         Goen Pivot Day Alert.mq4 |
//|                                           Copyright  2008, Goen |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Goen"

#property indicator_chart_window
#property indicator_buffers 3

extern int    Mode=0;
extern string MODE="0=HL 1=HLC 2=HLOC 3=HLCC";
extern color  Pivot1DColor=Aqua;
extern color  Pivot2DColor=Red;
extern color  Pivot3DColor=Yellow;
extern bool   ActivateAlert=True;
extern bool   ShowPrice=True;
extern color  PriceColor=Silver;

//---- buffers 
double Pivot1D[],Pivot2D[],Pivot3D[];
string sMode[]  = {"(HL/2)", "(HLC/3)", "(HLOC/4)", "(HLCC/4)"}; 

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   SetIndexStyle(0,DRAW_LINE,0,2,Pivot1DColor);
   SetIndexBuffer(0,Pivot1D);
   SetIndexLabel(0,"Pivot 1D " + sMode[Mode]);
   SetIndexStyle(1,DRAW_LINE,0,2,Pivot2DColor);
   SetIndexBuffer(1,Pivot2D);
   SetIndexLabel(1,"Pivot 2D " + sMode[Mode]);
   SetIndexStyle(2,DRAW_LINE,0,2,Pivot3DColor);
   SetIndexBuffer(2,Pivot3D);
   SetIndexLabel(2,"Pivot 3D " + sMode[Mode]);
   IndicatorShortName("Goen Pivot "+sMode[Mode]);

   int YPos=3;
   for(int i = 0; i<= ObjectsTotal() ; i++)
   {  if (ObjectGet(ObjectName(i),OBJPROP_YDISTANCE)==YPos && ObjectGet(ObjectName(i),OBJPROP_XDISTANCE)==3)
      {  YPos+=10;  i=0;}
   }
   
   string label0 = "GP"+Mode;
   ObjectCreate( label0, OBJ_LABEL, 0, 0, 0 );
   ObjectSetText(label0,"GOEN Pivot",8, "Arial Bold", Silver);
   ObjectSet( label0, OBJPROP_CORNER, 2 );
   ObjectSet( label0, OBJPROP_COLOR, Silver);
   ObjectSet( label0, OBJPROP_XDISTANCE, 3 );
   ObjectSet( label0, OBJPROP_YDISTANCE, YPos );
   return(0);  
  }
//----
   
int deinit()
  {
//----
   if (ShowPrice) 
   {  ObjectDelete("Goen Pivot 1D"+Mode);
      ObjectDelete("Goen Pivot 2D"+Mode);
      ObjectDelete("Goen Pivot 3D"+Mode);
   }   
   ObjectDelete("GP"+Mode);
//----
   return(0);
  } 
//+------------------------------------------------------------------+
//| MTF Moving Average                                   |
//+------------------------------------------------------------------+
int start()
  {
   datetime TimeArray[];
   int    i,shift,limit,y=0,x=0,counted_bars=IndicatorCounted();
   
   if (Period()>PERIOD_D1) return(0);
   ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),PERIOD_D1); 
   limit=Bars-counted_bars;
   for(i=0,y=0;i<limit;i++)
   {
      if (Time[i]<TimeArray[y]) y++;
      if (Mode==0)
      {  
         Pivot1D[i]=(iHigh(NULL,PERIOD_D1,y+1) + iLow(NULL,PERIOD_D1,y+1))/2;
         if (MathMod(TimeDay(Time[i]),2)<1)
         Pivot2D[i]= (MathMax(iHigh(NULL,PERIOD_D1,y+1),iHigh(NULL,PERIOD_D1,y+2)) + 
                      MathMin(iLow(NULL,PERIOD_D1,y+1),iLow(NULL,PERIOD_D1,y+2)))/2;
         else Pivot2D[i]= (MathMax(iHigh(NULL,PERIOD_D1,y+2),iHigh(NULL,PERIOD_D1,y+3)) + 
                           MathMin(iLow(NULL,PERIOD_D1,y+2),iLow(NULL,PERIOD_D1,y+3)))/2;

         if (MathMod(TimeDay(Time[i]),3)<1)
         Pivot3D[i]= (MathMax(MathMax(iHigh(NULL,PERIOD_D1,y+1),iHigh(NULL,PERIOD_D1,y+2)),iHigh(NULL,PERIOD_D1,y+3)) + 
                       MathMin(MathMin(iLow(NULL,PERIOD_D1,y+1),iLow(NULL,PERIOD_D1,y+2)),iLow(NULL,PERIOD_D1,y+3)))/2;
         else if (MathMod(TimeDay(Time[i]),3)<2)      
         Pivot3D[i]= (MathMax(MathMax(iHigh(NULL,PERIOD_D1,y+2),iHigh(NULL,PERIOD_D1,y+3)),iHigh(NULL,PERIOD_D1,y+4)) + 
                       MathMin(MathMin(iLow(NULL,PERIOD_D1,y+2),iLow(NULL,PERIOD_D1,y+3)),iLow(NULL,PERIOD_D1,y+4)))/2;
         else 
         Pivot3D[i]= (MathMax(MathMax(iHigh(NULL,PERIOD_D1,y+3),iHigh(NULL,PERIOD_D1,y+4)),iHigh(NULL,PERIOD_D1,y+5)) + 
                       MathMin(MathMin(iLow(NULL,PERIOD_D1,y+3),iLow(NULL,PERIOD_D1,y+4)),iLow(NULL,PERIOD_D1,y+5)))/2;
      }
      else if (Mode==1)
      {  
         Pivot1D[i]=(iHigh(NULL,PERIOD_D1,y+1) + iLow(NULL,PERIOD_D1,y+1)+
                     iClose(NULL,PERIOD_D1,y+1))/3;
         if (MathMod(TimeDay(Time[i]),2)<1)
         Pivot2D[i]= (MathMax(iHigh(NULL,PERIOD_D1,y+1),iHigh(NULL,PERIOD_D1,y+2)) + 
                      MathMin(iLow(NULL,PERIOD_D1,y+1),iLow(NULL,PERIOD_D1,y+2)) +
                      iClose(NULL,PERIOD_D1,y+1))/3;
         else Pivot2D[i]= (MathMax(iHigh(NULL,PERIOD_D1,y+2),iHigh(NULL,PERIOD_D1,y+3)) + 
                           MathMin(iLow(NULL,PERIOD_D1,y+2),iLow(NULL,PERIOD_D1,y+3)) +
                           iClose(NULL,PERIOD_D1,y+2))/3;
         if (MathMod(TimeDay(Time[i]),3)<1)
         Pivot3D[i]= (MathMax(MathMax(iHigh(NULL,PERIOD_D1,y+1),iHigh(NULL,PERIOD_D1,y+2)),iHigh(NULL,PERIOD_D1,y+3)) + 
                       MathMin(MathMin(iLow(NULL,PERIOD_D1,y+1),iLow(NULL,PERIOD_D1,y+2)),iLow(NULL,PERIOD_D1,y+3)) +
                       iClose(NULL,PERIOD_D1,y+1))/3;
         else if (MathMod(TimeDay(Time[i]),3)<2)      
         Pivot3D[i]= (MathMax(MathMax(iHigh(NULL,PERIOD_D1,y+2),iHigh(NULL,PERIOD_D1,y+3)),iHigh(NULL,PERIOD_D1,y+4)) + 
                       MathMin(MathMin(iLow(NULL,PERIOD_D1,y+2),iLow(NULL,PERIOD_D1,y+3)),iLow(NULL,PERIOD_D1,y+4)) +
                       iClose(NULL,PERIOD_D1,y+2))/3;
         else 
         Pivot3D[i]= (MathMax(MathMax(iHigh(NULL,PERIOD_D1,y+3),iHigh(NULL,PERIOD_D1,y+4)),iHigh(NULL,PERIOD_D1,y+5)) + 
                       MathMin(MathMin(iLow(NULL,PERIOD_D1,y+3),iLow(NULL,PERIOD_D1,y+4)),iLow(NULL,PERIOD_D1,y+5))+
                       iClose(NULL,PERIOD_D1,y+3))/3;
      }
      else if (Mode==2)
      {  Pivot1D[i]=(iHigh(NULL,PERIOD_D1,y+1) + iLow(NULL,PERIOD_D1,y+1)+
                     iOpen(NULL,PERIOD_D1,y+1) + iClose(NULL,PERIOD_D1,y+1))/4;
         if (MathMod(TimeDay(Time[i]),2)<1)
         Pivot2D[i]= (MathMax(iHigh(NULL,PERIOD_D1,y+1),iHigh(NULL,PERIOD_D1,y+2)) + 
                      MathMin(iLow(NULL,PERIOD_D1,y+1),iLow(NULL,PERIOD_D1,y+2)) +
                      iOpen(NULL,PERIOD_D1,y+2) + iClose(NULL,PERIOD_D1,y+1))/4;
         else Pivot2D[i]= (MathMax(iHigh(NULL,PERIOD_D1,y+2),iHigh(NULL,PERIOD_D1,y+3)) + 
                           MathMin(iLow(NULL,PERIOD_D1,y+2),iLow(NULL,PERIOD_D1,y+3)) +
                           iOpen(NULL,PERIOD_D1,y+3) + iClose(NULL,PERIOD_D1,y+2))/4;
         if (MathMod(TimeDay(Time[i]),3)<1)
         Pivot3D[i]= (MathMax(MathMax(iHigh(NULL,PERIOD_D1,y+1),iHigh(NULL,PERIOD_D1,y+2)),iHigh(NULL,PERIOD_D1,y+3)) + 
                       MathMin(MathMin(iLow(NULL,PERIOD_D1,y+1),iLow(NULL,PERIOD_D1,y+2)),iLow(NULL,PERIOD_D1,y+3)) +
                       iOpen(NULL,PERIOD_D1,y+3) + iClose(NULL,PERIOD_D1,y+1))/4;
         else if (MathMod(TimeDay(Time[i]),3)<2)      
         Pivot3D[i]= (MathMax(MathMax(iHigh(NULL,PERIOD_D1,y+2),iHigh(NULL,PERIOD_D1,y+3)),iHigh(NULL,PERIOD_D1,y+4)) + 
                       MathMin(MathMin(iLow(NULL,PERIOD_D1,y+2),iLow(NULL,PERIOD_D1,y+3)),iLow(NULL,PERIOD_D1,y+4)) +
                       iOpen(NULL,PERIOD_D1,y+4) + iClose(NULL,PERIOD_D1,y+2))/4;
         else 
         Pivot3D[i]= (MathMax(MathMax(iHigh(NULL,PERIOD_D1,y+3),iHigh(NULL,PERIOD_D1,y+4)),iHigh(NULL,PERIOD_D1,y+5)) + 
                       MathMin(MathMin(iLow(NULL,PERIOD_D1,y+3),iLow(NULL,PERIOD_D1,y+4)),iLow(NULL,PERIOD_D1,y+5))+
                       iOpen(NULL,PERIOD_D1,y+5) + iClose(NULL,PERIOD_D1,y+3))/4;

      }
      else if (Mode==3)
      {  
         Pivot1D[i]=(iHigh(NULL,PERIOD_D1,y+1) + iLow(NULL,PERIOD_D1,y+1)+
                     iClose(NULL,PERIOD_D1,y+1)*2)/4;
         if (MathMod(TimeDay(Time[i]),2)<1)
         Pivot2D[i]= (MathMax(iHigh(NULL,PERIOD_D1,y+1),iHigh(NULL,PERIOD_D1,y+2)) + 
                      MathMin(iLow(NULL,PERIOD_D1,y+1),iLow(NULL,PERIOD_D1,y+2)) +
                      iClose(NULL,PERIOD_D1,y+1)*2)/4;
         else Pivot2D[i]= (MathMax(iHigh(NULL,PERIOD_D1,y+2),iHigh(NULL,PERIOD_D1,y+3)) + 
                           MathMin(iLow(NULL,PERIOD_D1,y+2),iLow(NULL,PERIOD_D1,y+3)) +
                           iClose(NULL,PERIOD_D1,y+2)*2)/4;
         if (MathMod(TimeDay(Time[i]),3)<1)
         Pivot3D[i]= (MathMax(MathMax(iHigh(NULL,PERIOD_D1,y+1),iHigh(NULL,PERIOD_D1,y+2)),iHigh(NULL,PERIOD_D1,y+3)) + 
                       MathMin(MathMin(iLow(NULL,PERIOD_D1,y+1),iLow(NULL,PERIOD_D1,y+2)),iLow(NULL,PERIOD_D1,y+3)) +
                       iClose(NULL,PERIOD_D1,y+1)*2)/4;
         else if (MathMod(TimeDay(Time[i]),3)<2)      
         Pivot3D[i]= (MathMax(MathMax(iHigh(NULL,PERIOD_D1,y+2),iHigh(NULL,PERIOD_D1,y+3)),iHigh(NULL,PERIOD_D1,y+4)) + 
                       MathMin(MathMin(iLow(NULL,PERIOD_D1,y+2),iLow(NULL,PERIOD_D1,y+3)),iLow(NULL,PERIOD_D1,y+4)) +
                       iClose(NULL,PERIOD_D1,y+2)*2)/4;
         else 
         Pivot3D[i]= (MathMax(MathMax(iHigh(NULL,PERIOD_D1,y+3),iHigh(NULL,PERIOD_D1,y+4)),iHigh(NULL,PERIOD_D1,y+5)) + 
                       MathMin(MathMin(iLow(NULL,PERIOD_D1,y+3),iLow(NULL,PERIOD_D1,y+4)),iLow(NULL,PERIOD_D1,y+5))+
                       iClose(NULL,PERIOD_D1,y+3)*2)/4;
      }
   }
   
   if (ActivateAlert)
   {
   static int Last1D=0,Last2D=0,Last3D=0;
   if (Last1D!=Bars)
   {  if (Open[0]<Pivot1D[0] && Bid > Pivot1D[0]) Alert("Price crossing up Pivot 4H ("+sMode[Mode]+")");
      if (Open[0]>Pivot1D[0] && Bid < Pivot1D[0]) Alert("Price crossing down Pivot 4H ("+sMode[Mode]+")");
      Last1D=Bars;
   }
   if (Last2D!=Bars)
   {  if (Open[0]<Pivot2D[0] && Bid > Pivot2D[0]) Alert("Price crossing up Pivot 8H ("+sMode[Mode]+")");
      if (Open[0]>Pivot2D[0] && Bid < Pivot2D[0]) Alert("Price crossing down Pivot 8H ("+sMode[Mode]+")");
      Last2D=Bars;
   }
   if (Last3D!=Bars)
   {  if (Open[0]<Pivot3D[0] && Bid > Pivot3D[0]) Alert("Price crossing up Pivot 12H ("+sMode[Mode]+")");
      if (Open[0]>Pivot3D[0] && Bid < Pivot3D[0]) Alert("Price crossing down Pivot 12H ("+sMode[Mode]+")");
      Last3D=Bars;
   }
   }

   if (ShowPrice)
   {
      string label = "Goen Pivot 1D"+Mode;
      ObjectDelete(label);
      ObjectCreate( label, OBJ_ARROW, 0, 0, 0 );
      ObjectSet( label, OBJPROP_ARROWCODE, SYMBOL_RIGHTPRICE);
      ObjectSet( label, OBJPROP_COLOR, PriceColor);
      ObjectSet( label, OBJPROP_TIME1, Time[0]);
      ObjectSet( label, OBJPROP_PRICE1, Pivot1D[0]);  
      
      label = "Goen Pivot 2D"+Mode;
      ObjectDelete(label);
      ObjectCreate( label, OBJ_ARROW, 0, 0, 0 );
      ObjectSet( label, OBJPROP_ARROWCODE, SYMBOL_RIGHTPRICE);
      ObjectSet( label, OBJPROP_COLOR, PriceColor);
      ObjectSet( label, OBJPROP_TIME1, Time[0]);
      ObjectSet( label, OBJPROP_PRICE1, Pivot2D[0]);  
   
      label = "Goen Pivot 3D"+Mode;
      ObjectDelete(label);
      ObjectCreate( label, OBJ_ARROW, 0, 0, 0 );
      ObjectSet( label, OBJPROP_ARROWCODE, SYMBOL_RIGHTPRICE);
      ObjectSet( label, OBJPROP_COLOR, PriceColor);
      ObjectSet( label, OBJPROP_TIME1, Time[0]);
      ObjectSet( label, OBJPROP_PRICE1, Pivot3D[0]);  
   }   
   return(0);
  }
//+------------------------------------------------------------------+